/* 
 * This is source code to CASL (Custom Audit Scripting Language)
 *
 * Copyright 1998 Secure Networks, Inc.
 * Copyright 1999 Network Associates, Inc.
 * All Rights Reserved
 *
 * BEFORE YOU INSTALL, USE, OR MODIFY THIS SOFTWARE PRODUCT,
 * CAREFULLY READ THE TERMS AND CONDITIONS IN THE FILE
 * "LICENSE.TXT" ACCOMPANYING THIS DOCUMENT. IF THE FILE
 * "LICENSE.TXT" IS MISSING, IT MAY BE OBTAINED FROM
 * NETWORK ASSOCIATES. NETWORK ASSOCIATES IS PERMITTING
 * THE USE, DISTRIBUTION, AND LIMITED MODIFICATION OF THIS
 * SOFTWARE PRODUCT ON A NON-COMMERCIAL BASIS SUBJECT TO
 * ALL OF THE CONDITIONS IN THE FILE "LICENSE.TXT." BY INSTALLING,
 * USING, OR MODIFYING THE SOFTWARE PRODUCT, YOU AND ANY
 * SUBSEQUENT USER ARE AGREEING TO BE BOUND BY ALL OF THE
 * TERMS AND CONDITIONS IN THE FILE "LICENSE.TXT." IF YOU DO
 * NOT AGREE TO ALL OF THOSE TERMS AND CONDITIONS, DO NOT
 * INSTALL, USE, OR MODIFY THIS SOFTWARE PRODUCT.
 */

#include "casl-asr.h"

/* How many children does each node have? */
/* XXX Fixme - Need a way to specify how many pets, and if the node even has
   a house, too. */
struct arity arity_table[] = {
	{ N_ID,		0 },
	{ N_INT,	0 },
	{ N_NEGINT,	0 },
	{ N_STRING,	0 },
	{ N_CHAR,	0 },

	{ LIST,		2 },
	
	{ N_CALL,	2 },
	{ N_ASSIGN,	2 },
	{ N_IDX,	3 },
	{ N_FIELD,	2 },
	{ N_RANGE,	2 },

	{ N_ITE,	3 },
	{ N_FOR,	4 },
	{ N_WHILE,	2 },
	{ N_FOREACH,	3 },
	
	{ N_NEG,	1 },
	{ N_POP,	1 },

	{ N_PLUS,	2 },	
	{ N_MINUS,	2 },	
	{ N_MUL,	2 },	
	{ N_DIV,	2 },	
	{ N_EQ,		2 },	
	{ N_NE,		2 },	
	{ N_GT,		2 },	
	{ N_LT,		2 },	
	{ N_GE,		2 },	
	{ N_LE,		2 },	

	{ N_AND,	2 },
	{ N_OR,		2 },

	{ N_FUNC,	3 },
	{ N_BODY,	1 },
	
	{ N_STRUCT,	2 },
	{ N_STRUCTDEF,	2 },

	{ N_RETURN,	1 },
	
	{ N_SIZET,	0 },
	{ N_SIZESPEC,	2 },

	{ N_EXPR, 	1 },
	{ N_NEW,	2 },
	{ N_EXTRACT, 	2 },
	{ N_BUFFER,	0 },
	{ N_DEBUG,	1 },
	{ N_DUMP,	1 }, 
	{ N_NOT, 	1 },
	{ N_TAIL, 	1 },
	{ N_PLIST,	2 },
	{ N_PTAIL,	2 },
	{ N_SNAME,	1 },
	{ N_END,	1 },
	{ N_EXTRACT2,	2 },
	{ N_BREAK, 	0 },
	{ N_CONTINUE, 	0 },
	{ N_TRON,	0 },
	{ N_TROFF, 	0 },
	{ N_COPY,	1 },
	{ N_SCALE,	1 },
	{ N_MOD, 	2 },
	{ N_BLSHIFT,	2 },
	{ N_BRSHIFT,	2 },
	{ N_BOR,	2 },
	{ N_BAND,	2 },
	{ N_BXOR,	2 },
	{ N_BNOT,	1 },
	{ N_CREATELIST, 1 },
	{ N_PREINCR,	1 },
	{ N_PREDECR,	1 },
	{ N_POSTINCR,	1 },
	{ N_POSTDECR,	1 },
};
